<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

    * Redistributions must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    * The name of John Stevens may not
      be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?PHP
   include_once("security_check.php") ; 
	 
	 include "get_timer_lists.php" ;

// initialise timer count
$t_cnt = 0 ;

foreach($MyToppies as $servername)
{
 if ($use_cache[$servername]) { $cache = unserialize(file_get_contents($local_files.DIRECTORY_SEPARATOR.$servername."_timers_cache")) ; }
 else                         { $cache = $server_cache[$servername] ; }
 //echo "$servername=".$use_cache[$servername]." "; print_r($cache) ;
	 
 if ( !is_array($cache) ) { $use_cache[$servername] = false ; } // No cache exists
	 
 $types = $cache["pend_types"] ;
 $pending_timers = $cache["pend_timers"] ;
 $timers = $cache["current_timers"] ;
 $rec1 = $cache["rec1"] ;
 $rec2 = $cache["rec2"] ;
 $types["***|dummy|/***"] = "" ; // ensure at least one entry exists
 $pend_status = count(array_keys($types,"Delete"))." deletions and ".count(array_keys($types,"Add"))." additions pending" ;
 //print_r($pending_timers) ;

// Now overlay existing and pending timers
/*
if($ftp=ftp_connect($FTPaddress[$servername],$FTPport[$servername]))
{
 ftp_login($ftp,$FTPuser[$servername],$FTPpw[$servername]);
 ftp_chdir($ftp,$epg_timers_rem);
  
 // First overlay existing timers
 if(ftp_size($ftp,$epg_timers)>0)
 {
 	$get = ftp_get($ftp,$epg_timers_loc.DIRECTORY_SEPARATOR.$epg_timers,$epg_timers,FTP_BINARY);
 	$rows = file($epg_timers_loc.DIRECTORY_SEPARATOR.$epg_timers);
*/
	
	//foreach ($rows as $index => $line)
	foreach ($timers as $index => $line)
	{
	 $t_cnt += 1 ;
	 add_diag("timer count $t_cnt") ;
	 $values = explode("\t",$line);
	 //echo "$line<br>\n" ;
	 if($index <> 0 and count($values)>9)
	 {
	  if($values[9]=="Recording" or $show_vcr_timers_on_epg)	
		{
	   //echo $values[9]."=$line<br>\n" ;
		 $timer_title = substr_replace($values[0],"",-4) ;
		 //$timer_channel = $chn_names[$values[1]] ;
         if($TFuseLCN[$servername])
	     {
	 		//echo "LCN ".$values[11]."=".$lcn_chn_trans[$values[10]]." $timer\n" ;
			$timer_channel = $lcn_chn_trans[$values[11]] ;
	     }
		 else
		 {
		    $timer_channel = array_key_exists($values[1],$chn_names) ? $chn_names[$values[1]] : $values[1] ;
		 }
		 $timer_type = $values[5] ;
		 $timer_duration = $values[4] ;
		 if($values[9]=="Recording") { $timer_class = "timer_exist" ; }
		 else                        { $timer_class = "timer_vcr" ; }
		 $timer_start = substr($values[3],4,2)."/".substr($values[3],6,2)."/".substr($values[3],0,4)." ".substr($values[3],9,5) ;
		 $timer_startstamp = strtotime($timer_start) ;
		 $timer_stopstamp = $timer_startstamp+($timer_duration*60) ;
		 timer_display($timer_type,$servername,$timer_channel,$timer_startstamp,$timer_stopstamp,$timer_duration,$t_cnt,$timer_class,$timer_title) ;
		}
	 }
	} // end of existing timers
	
/*	 
 } 
*/ 
 
 
 
 // Now display any pending timers	
 
 /*
 ftp_chdir($ftp,$set_timers_rem);
 
	if(ftp_size($ftp,$set_timers_tgd)>0)
	{
	 $get = ftp_get($ftp,$set_timers_loc.DIRECTORY_SEPARATOR.$set_timers_tgd,$set_timers_tgd,FTP_BINARY);
 	 $rows = file($set_timers_loc.DIRECTORY_SEPARATOR.$set_timers_tgd);
	 */
	 
	
	 $add_count = 0;
	 $del_count = 0;
	 foreach ($pending_timers as $index => $line)
	 {
	   $t_cnt += 1 ;
	 	 $values = explode("\t",substr($line,0,-1));
		 $timer_title = $values[3] ;
		 echo "Line=$line\n" ;
         if($TFuseLCN[$servername])
	     {
		 	$timer_channel = $lcn_chn_trans[$values[0]] ;
		 }
         else
	     {
		 	$timer_channel = $values[0] ;
		 }
		 $timer_duration = $values[2] ;
		 $timer_type = $values[7] ;
		 if ($timer_type<>"WL" and $timer_type<>"ED" and $timer_type<>"WD" and $timer_type<>"WE" and $timer_type<>"D") { $timer_type = "Onetime" ; }
		 $timer_start = substr($values[1],5,2)."/".substr($values[1],8,2)."/".substr($values[1],0,4)." ".substr($values[1],11,5) ;
		 $timer_startstamp = strtotime($timer_start) ;
		 $timer_stopstamp = $timer_startstamp+($timer_duration*60) ;
		 
		 //echo "$timer_title | $timer_channel | $timer_duration | $timer_start | $timer_startstamp | $timer_stopstamp<br>\n" ;
	 	 if (substr($values[7],0,1)=="D")
		 {
		  $timer_class = "timer_delete" ;
			$timer_type = "Delete" ;
		 	$types[$index] = "Delete";
			$del_count++;
		 }
		 else
		 {
		  $timer_class = "timer_add" ;
		 	$types[$index] = "Add";
			$add_count++;
		 }
		 
		 //echo $values[7]." length=".strlen($values[7])."\n" ;
		 if (strlen($values[7])==7)
		 {
		  $prepad  = 0 + substr($values[7],0,3);
		  $postpad = 0 + substr($values[7],4,3);
		 }
		 else
		 {
		  $prepad  = 0 ;
			$postpad = 0 ;
		 }
		 //echo "padding = $prepad | $postpad \n";
		 $timer_startstamp += $prepad*60 ;
		 $timer_stopstamp  += $postpad*60 ;
		 $timer_duration   += $postpad - $prepad ;
		 timer_display($timer_type,$servername,$timer_channel,$timer_startstamp,$timer_stopstamp,$timer_duration,$t_cnt,$timer_class,$timer_title) ;
	}  // end of pending timers     
 
 // Now read the recplay file if it exists and show any active recordings
 
 /*
 $rec1 = $rec2 = $play = array("","","","","") ;
 //label <tab> filename <tab> channel <tab> start <tab> duration
 ftp_chdir($ftp,$epg_recplay_rem);
 if(ftp_size($ftp,$epg_recplay)>0)
 {
 	$get = ftp_get($ftp,$epg_recplay_loc.DIRECTORY_SEPARATOR.$epg_recplay,$epg_recplay,FTP_BINARY);
 	$rows = file($epg_recplay_loc.DIRECTORY_SEPARATOR.$epg_recplay);
	
	//echo $rows[0]."<br>\n" ;
	$rec1 = explode("\t",trim($rows[0])); //$rec1[1] = $data_files."/".rec1[1] ;
	$rec2 = explode("\t",trim($rows[1])); //$rec2[1] = $data_files."/".rec2[1] ;
	$play = explode("\t",trim($rows[2]));		
	*/
	
	if ($rec1[1]<>"")
	{
	   $t_cnt += 1 ;
	   //echo $values[9]."=$line<br>\n" ;
         if($TFuseLCN[$servername])
	     {
		 	$timer_channel = $lcn_chn_trans[$rec1[5]] ;
		 }
         else
	     {
		 	$timer_channel = array_key_exists($rec1[2],$chn_names) ? $chn_names[$rec1[2]] : $rec1[2] ;
		 }
		 $timer_type = "Active Recording" ;
		 $timer_duration = $rec1[4] ;
		 $timer_class = "timer_active" ; 
		 $timer_start = substr($rec1[3],4,2)."/".substr($rec1[3],6,2)."/".substr($rec1[3],0,4)." ".substr($rec1[3],9,5) ;
		 $timer_startstamp = strtotime($timer_start) ;
		 $timer_stopstamp = $timer_startstamp+($timer_duration*60) ;
		 timer_display($timer_type,$servername,$timer_channel,$timer_startstamp,$timer_stopstamp,$timer_duration,$t_cnt,$timer_class,$rec1[1]) ;
  }
	
	if ($rec2[1]<>"")
	{
	   $t_cnt += 1 ;
	   //echo $values[9]."=$line<br>\n" ;
		 //$timer_channel = $chn_names[$rec2[2]] ;
         if($TFuseLCN[$servername])
	     {
		 	$timer_channel = $lcn_chn_trans[$rec2[5]] ;
		 }
         else
	     {
		 	$timer_channel = array_key_exists($rec2[2],$chn_names) ? $chn_names[$rec2[2]] : $rec2[2] ;
		 }
		 $timer_type = "Active Recording" ;
		 $timer_duration = $rec2[4] ;
		 $timer_class = "timer_active" ; 
		 $timer_start = substr($rec2[3],4,2)."/".substr($rec2[3],6,2)."/".substr($rec2[3],0,4)." ".substr($rec2[3],9,5) ;
		 $timer_startstamp = strtotime($timer_start) ;
		 $timer_stopstamp = $timer_startstamp+($timer_duration*60) ;
		 timer_display($timer_type,$servername,$timer_channel,$timer_startstamp,$timer_stopstamp,$timer_duration,$t_cnt,$timer_class,$rec2[1]) ;
  }
	
 /*	
 }
 
 ftp_quit($ftp);
}
*/
} // end of server loop

function timer_display($timer_type,$servername,$timer_channel,$original_timer_startstamp,$original_timer_stopstamp,$timer_duration,$index,$timer_class,$timer_title="unknown")
{
 global $channel_left,$start_timestamp,$end_timestamp, $mouseover_display ;
 global $epg_head_height,$epg_head_height,$hour_height,$timer_offset,$chn_width,$timer_width,$time_head_width ; 
 //echo "timertype=$timer_type\n" ;
 
 for ($i=0; $i<7 ; $i+=1)
 {
  $timer_startstamp = $original_timer_startstamp+($i*24*60*60) ;
  $timer_stopstamp = $original_timer_stopstamp+($i*24*60*60) ;
	$dayofweek = date("D",$timer_startstamp) ;
	//echo "$i=$dayofweek\n" ;
  
	switch ($timer_type."_".$i)
	{
	 case "Active Recording_0" :
	 case "Onetime_0" :
	 case "D_0"       :
	 case "Delete_0"       :
	 case "Weekly_0"  :
	 case "WD_0"      :
	  $showtimer = true ;
		break ;
	 default :
    switch ($timer_type."_".$dayofweek)
	  {
	   case "ED_Mon" :
	   case "ED_Tue" :
	   case "ED_Wed" :
	   case "ED_Thu" :
	   case "ED_Fri" :
	   case "ED_Sat" :
	   case "ED_Sun" :
	   case "WD_Mon" :
	   case "WD_Tue" :
	   case "WD_Wed" :
	   case "WD_Thu" :
	   case "WE_Sat" :
	   case "WE_Sun" :
	   case "Everyday_Mon" :
	   case "Everyday_Tue" :
	   case "Everyday_Wed" :
	   case "Everyday_Thu" :
	   case "Everyday_Fri" :
	   case "Everyday_Sat" :
	   case "Everyday_Sun" :
	   case "WeekDay_Mon" :
	   case "WeekDay_Tue" :
	   case "WeekDay_Wed" :
	   case "WeekDay_Thu" :
	   case "WeekDay_Fri" :
	   case "EveryWeekend_Sat" :
	   case "EveryWeekend_Sun" :
		  $showtimer = true ;
		  break ;
		 default :
		  $showtimer = false ;
	  }
	 }
	if($showtimer)
	{
		 //echo "$start_timestamp | $timer_startstamp | $timer_stopstamp | $end_timestamp<br>\n" ;
		 $s1=$start_timestamp <= $timer_startstamp ;
		 $s2=$timer_startstamp < $end_timestamp-1 ;
		 $e1=$start_timestamp+1 < $timer_stopstamp ;
		 $e2=$timer_stopstamp <= $end_timestamp ;
		 $is_today=(($s1 and $s2) or ($e1 and $e2)) ;
		 //echo "$s1 | $s2 | $e1 | $e2 | ".($s1 and $s2)." | ".($e1 and $e2)." | $is_today \n" ;
		 $chn_left = array_key_exists($echn=epg_channel($timer_channel),$channel_left) ? $channel_left[$echn] : ($time_head_width-$chn_width) ;
		 //if ( ($is_today) and array_key_exists($timer_channel,$channel_left) )
		 if ( $is_today )
		 {		 
		  $timer_offset = max($timer_startstamp - $start_timestamp,0) ;
		  $d_top = round($epg_head_height+($hour_height*($timer_offset/3600)))."px" ;
		  //$d_left = round($channel_left[$timer_channel]+$chn_width-$timer_width)."px" ;
		  $d_left = round($chn_left+$chn_width-$timer_width)."px" ;
		  $d_width = round($timer_width-0)."px" ;
		  $d_height = round(($hour_height*($timer_duration-(max($timer_stopstamp-$end_timestamp,0)-min($timer_startstamp - $start_timestamp,0))/60))/60)."px" ;
			
 
      if ( $mouseover_display >= $duration )
      {
       $mouseover_action = "mouseover_timer_show(this,$index);" ;
       $mouseout_action  = "mouseover_hide(this,$index);" ;
			 $action = "onMouseOver='$mouseover_action' onMouseOut='$mouseout_action'" ;
      }
      else
      {
			 $action = "" ;
      }
			
      //echo "<div id='$timer_class$index' class='$timer_class' style='position:absolute; top:$d_top; height:$d_height; left:$d_left; width:$d_width;'>\n" ;
			echo "<div id='$timer_class$index' class='$timer_class' $action style='position:absolute; top:$d_top; height:$d_height; left:$d_left; width:$d_width;'>\n" ;
			//echo $timer_title ;
			echo "<span id='timer_channel_$index'  style='display:none'>$timer_channel ($servername)</span>\n" ;
			echo "<span id='timer_time_$index'    style='display:none'>".date("H:i",$timer_startstamp)."</span>\n" ;
			echo "<span id='timer_title_$index'    style='display:none'>$timer_title</span>\n" ;
			echo "<span id='timer_duration_$index' style='display:none'>$timer_duration</span>\n" ;
			echo "<span id='timer_type_$index'     style='display:none'>$timer_type</span>\n" ;
			echo "<span id='timer_class_$index'    style='display:none'>$timer_class</span>\n" ;
			echo "</div>\n" ;
			//echo "<br>\n" ;
		}
	}
 }
}

function epg_channel($timer_channel)
{
 global $channel_left,$chn_alternate,$chn_hdtv ;
 
 if(array_key_exists($timer_channel,$channel_left)) { return $timer_channel ; } 
 if ($chn = array_search($timer_channel,$chn_alternate)) { return $chn ; }
 if ($chn = array_search($timer_channel,$chn_hdtv)) { return $chn ; }
 return $timer_channel ;
}

?>
